Count message tokens (estimate)
An estimate of a Messages request’s input tokens: its text at four characters a token, 1,000 tokens an image and four a message. Not billed. The usage on the response is the exact count.
curl --request POST \
--url https://api.runcrate.ai/v1/messages/count_tokens \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"model": "<string>",
"messages": [
{}
],
"system": "<string>",
"max_tokens": 2,
"temperature": 123,
"top_p": 123,
"top_k": 123,
"stop_sequences": [
"<string>"
],
"stream": false,
"tools": [
{}
],
"tool_choice": {},
"thinking": {},
"metadata": {}
}
'import requests
url = "https://api.runcrate.ai/v1/messages/count_tokens"
payload = {
"model": "<string>",
"messages": [{}],
"system": "<string>",
"max_tokens": 2,
"temperature": 123,
"top_p": 123,
"top_k": 123,
"stop_sequences": ["<string>"],
"stream": False,
"tools": [{}],
"tool_choice": {},
"thinking": {},
"metadata": {}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
model: '<string>',
messages: [{}],
system: '<string>',
max_tokens: 2,
temperature: 123,
top_p: 123,
top_k: 123,
stop_sequences: ['<string>'],
stream: false,
tools: [{}],
tool_choice: {},
thinking: {},
metadata: {}
})
};
fetch('https://api.runcrate.ai/v1/messages/count_tokens', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.runcrate.ai/v1/messages/count_tokens",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'model' => '<string>',
'messages' => [
[
]
],
'system' => '<string>',
'max_tokens' => 2,
'temperature' => 123,
'top_p' => 123,
'top_k' => 123,
'stop_sequences' => [
'<string>'
],
'stream' => false,
'tools' => [
[
]
],
'tool_choice' => [
],
'thinking' => [
],
'metadata' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.runcrate.ai/v1/messages/count_tokens"
payload := strings.NewReader("{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.runcrate.ai/v1/messages/count_tokens")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.runcrate.ai/v1/messages/count_tokens")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}"
response = http.request(request)
puts response.read_body{
"input_tokens": 123
}{
"error": {
"code": "<string>",
"message": "<string>",
"details": {}
}
}Authorizations
Use a Runcrate API key with the rc_live_* prefix as the bearer token. Create one at https://www.runcrate.ai/dashboard/api-keys.
Body
A Runcrate model id (e.g. deepseek-ai/DeepSeek-V4.1-Flash). Claude model names such as claude-sonnet-4-5 are not Runcrate ids and answer 404.
Turns with role (user or assistant) and content: a string, or blocks of type text, image (base64 or url source), document (text source), tool_use and tool_result (with is_error). thinking blocks sent back are accepted and not passed to the model.
A string or text blocks; cache_control is kept.
x >= 1Custom tools with name, description and input_schema.
{type: auto | any | tool | none}; tool takes name; disable_parallel_tool_use is honored.
{type: enabled, budget_tokens} sets the reasoning effort: under 4,096 low, under 16,384 medium, else high. output_config.effort takes precedence.
Accepted and never sent to the model.
Response
The estimate.
curl --request POST \
--url https://api.runcrate.ai/v1/messages/count_tokens \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"model": "<string>",
"messages": [
{}
],
"system": "<string>",
"max_tokens": 2,
"temperature": 123,
"top_p": 123,
"top_k": 123,
"stop_sequences": [
"<string>"
],
"stream": false,
"tools": [
{}
],
"tool_choice": {},
"thinking": {},
"metadata": {}
}
'import requests
url = "https://api.runcrate.ai/v1/messages/count_tokens"
payload = {
"model": "<string>",
"messages": [{}],
"system": "<string>",
"max_tokens": 2,
"temperature": 123,
"top_p": 123,
"top_k": 123,
"stop_sequences": ["<string>"],
"stream": False,
"tools": [{}],
"tool_choice": {},
"thinking": {},
"metadata": {}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
model: '<string>',
messages: [{}],
system: '<string>',
max_tokens: 2,
temperature: 123,
top_p: 123,
top_k: 123,
stop_sequences: ['<string>'],
stream: false,
tools: [{}],
tool_choice: {},
thinking: {},
metadata: {}
})
};
fetch('https://api.runcrate.ai/v1/messages/count_tokens', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.runcrate.ai/v1/messages/count_tokens",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'model' => '<string>',
'messages' => [
[
]
],
'system' => '<string>',
'max_tokens' => 2,
'temperature' => 123,
'top_p' => 123,
'top_k' => 123,
'stop_sequences' => [
'<string>'
],
'stream' => false,
'tools' => [
[
]
],
'tool_choice' => [
],
'thinking' => [
],
'metadata' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.runcrate.ai/v1/messages/count_tokens"
payload := strings.NewReader("{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.runcrate.ai/v1/messages/count_tokens")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.runcrate.ai/v1/messages/count_tokens")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"model\": \"<string>\",\n \"messages\": [\n {}\n ],\n \"system\": \"<string>\",\n \"max_tokens\": 2,\n \"temperature\": 123,\n \"top_p\": 123,\n \"top_k\": 123,\n \"stop_sequences\": [\n \"<string>\"\n ],\n \"stream\": false,\n \"tools\": [\n {}\n ],\n \"tool_choice\": {},\n \"thinking\": {},\n \"metadata\": {}\n}"
response = http.request(request)
puts response.read_body{
"input_tokens": 123
}{
"error": {
"code": "<string>",
"message": "<string>",
"details": {}
}
}